diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/spectrum/model/aloha-noack-net-device.cc ns-3.39/src/spectrum/model/aloha-noack-net-device.cc
--- ns-3.38/src/spectrum/model/aloha-noack-net-device.cc	2023-03-16 20:54:23.824869200 -0700
+++ ns-3.39/src/spectrum/model/aloha-noack-net-device.cc	2023-07-05 14:23:48.081428300 -0700
@@ -374,7 +374,7 @@
         else
         {
             NS_LOG_LOGIC("enqueueing new packet");
-            if (m_queue->Enqueue(packet) == false)
+            if (!m_queue->Enqueue(packet))
             {
                 m_macTxDropTrace(packet);
                 sendOk = false;
@@ -385,7 +385,7 @@
     {
         NS_LOG_LOGIC("deferring TX, enqueueing new packet");
         NS_ASSERT(m_queue);
-        if (m_queue->Enqueue(packet) == false)
+        if (!m_queue->Enqueue(packet))
         {
             m_macTxDropTrace(packet);
             sendOk = false;
@@ -426,7 +426,7 @@
     NS_ASSERT_MSG(m_state == TX, "TX end notified while state != TX");
     m_state = IDLE;
     NS_ASSERT(m_queue);
-    if (m_queue->IsEmpty() == false)
+    if (!m_queue->IsEmpty())
     {
         Ptr<Packet> p = m_queue->Dequeue();
         NS_ASSERT(p);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/spectrum/model/half-duplex-ideal-phy.cc ns-3.39/src/spectrum/model/half-duplex-ideal-phy.cc
--- ns-3.38/src/spectrum/model/half-duplex-ideal-phy.cc	2023-03-16 20:54:23.824869200 -0700
+++ ns-3.39/src/spectrum/model/half-duplex-ideal-phy.cc	2023-07-05 14:23:48.081428300 -0700
@@ -302,9 +302,7 @@
     break;
 
     case TX:
-
         return true;
-        break;
     }
     return false;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/spectrum/model/ism-spectrum-value-helper.cc ns-3.39/src/spectrum/model/ism-spectrum-value-helper.cc
--- ns-3.38/src/spectrum/model/ism-spectrum-value-helper.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/src/spectrum/model/ism-spectrum-value-helper.cc	2023-07-05 14:23:48.081428300 -0700
@@ -0,0 +1,97 @@
+/*
+ * Copyright (c) 2009 CTTC
+ * Copyright (c) 2010 TELEMATICS LAB, DEE - Politecnico di Bari
+ * Copyright (c) 2017 Orange Labs
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Nicola Baldo <nbaldo@cttc.es>
+ *          Giuseppe Piro <g.piro@poliba.it>
+ */
+
+#include "ism-spectrum-value-helper.h"
+
+#include "ns3/assert.h"
+#include "ns3/log.h"
+
+namespace ns3
+{
+
+NS_LOG_COMPONENT_DEFINE("IsmSpectrumValueHelper");
+
+static Ptr<SpectrumModel> g_WifiSpectrumModel5Mhz; ///< static initializer for the class
+
+/**
+ * Static class to initialize the values for the 2.4 GHz Wi-Fi spectrum model
+ */
+static class WifiSpectrumModel5MhzInitializer
+{
+  public:
+    WifiSpectrumModel5MhzInitializer()
+    {
+        Bands bands;
+        for (int i = -4; i < 13 + 7; i++)
+        {
+            BandInfo bi;
+            bi.fl = 2407.0e6 + i * 5.0e6;
+            bi.fh = 2407.0e6 + (i + 1) * 5.0e6;
+            bi.fc = (bi.fl + bi.fh) / 2;
+            bands.push_back(bi);
+        }
+        g_WifiSpectrumModel5Mhz = Create<SpectrumModel>(bands);
+    }
+} g_WifiSpectrumModel5MhzInitializerInstance; //!< initialization instance for WifiSpectrumModel5Mhz
+
+Ptr<SpectrumValue>
+SpectrumValue5MhzFactory::CreateConstant(double v)
+{
+    Ptr<SpectrumValue> c = Create<SpectrumValue>(g_WifiSpectrumModel5Mhz);
+    (*c) = v;
+    return c;
+}
+
+Ptr<SpectrumValue>
+SpectrumValue5MhzFactory::CreateTxPowerSpectralDensity(double txPower, uint8_t channel)
+{
+    Ptr<SpectrumValue> txPsd = Create<SpectrumValue>(g_WifiSpectrumModel5Mhz);
+
+    // since the spectrum model has a resolution of 5 MHz, we model
+    // the transmitted signal with a constant density over a 20MHz
+    // bandwidth centered on the center frequency of the channel. The
+    // transmission power outside the transmission power density is
+    // calculated considering the transmit spectrum mask, see IEEE
+    // Std. 802.11-2007, Annex I
+
+    double txPowerDensity = txPower / 20e6;
+
+    NS_ASSERT(channel >= 1);
+    NS_ASSERT(channel <= 13);
+
+    (*txPsd)[channel - 1] = txPowerDensity * 1e-4;      // -40dB
+    (*txPsd)[channel] = txPowerDensity * 1e-4;          // -40dB
+    (*txPsd)[channel + 1] = txPowerDensity * 0.0015849; // -28dB
+    (*txPsd)[channel + 2] = txPowerDensity * 0.0015849; // -28dB
+    (*txPsd)[channel + 3] = txPowerDensity;
+    (*txPsd)[channel + 4] = txPowerDensity;
+    (*txPsd)[channel + 5] = txPowerDensity;
+    (*txPsd)[channel + 6] = txPowerDensity;
+    (*txPsd)[channel + 7] = txPowerDensity * 0.0015849; // -28dB
+    (*txPsd)[channel + 8] = txPowerDensity * 0.0015849; // -28dB
+    (*txPsd)[channel + 9] = txPowerDensity * 1e-4;      // -40dB
+    (*txPsd)[channel + 10] = txPowerDensity * 1e-4;     // -40dB
+
+    return txPsd;
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/spectrum/model/ism-spectrum-value-helper.h ns-3.39/src/spectrum/model/ism-spectrum-value-helper.h
--- ns-3.38/src/spectrum/model/ism-spectrum-value-helper.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/src/spectrum/model/ism-spectrum-value-helper.h	2023-07-05 14:23:48.081428300 -0700
@@ -0,0 +1,76 @@
+/*
+ * Copyright (c) 2009 CTTC
+ * Copyright (c) 2017 Orange Labs
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Nicola Baldo <nbaldo@cttc.es>
+ *          Giuseppe Piro <g.piro@poliba.it>
+ */
+
+#ifndef ISM_SPECTRUM_VALUE_HELPER_H
+#define ISM_SPECTRUM_VALUE_HELPER_H
+
+#include <ns3/spectrum-value.h>
+
+namespace ns3
+{
+
+/**
+ * \ingroup spectrum
+ *
+ * Implements Wifi SpectrumValue for the 2.4 GHz ISM band only, with a
+ * 5 MHz spectrum resolution.
+ *
+ */
+class SpectrumValue5MhzFactory
+{
+  public:
+    /**
+     * Destructor
+     */
+    virtual ~SpectrumValue5MhzFactory() = default;
+    /**
+     * Creates a SpectrumValue instance with a constant value for all frequencies
+     *
+     * @param psd the constant value
+     *
+     * @return a Ptr to a newly created SpectrumValue
+     */
+    virtual Ptr<SpectrumValue> CreateConstant(double psd);
+    /**
+     * Creates a SpectrumValue instance that represents the TX Power Spectral
+     * Density  of a wifi device corresponding to the provided parameters
+     *
+     * Since the spectrum model has a resolution of 5 MHz, we model
+     * the transmitted signal with a constant density over a 20MHz
+     * bandwidth centered on the center frequency of the channel. The
+     * transmission power outside the transmission power density is
+     * calculated considering the transmit spectrum mask, see IEEE
+     * Std. 802.11-2007, Annex I.  The two bands just outside of the main
+     * 20 MHz are allocated power at -28 dB down from the center 20 MHz,
+     * and the two bands outside of this are allocated power at -40 dB down
+     * (with a total bandwidth of 60 MHz containing non-zero power allocation).
+     *
+     * @param txPower the total TX power in W
+     * @param channel the number of the channel (1 <= channel <= 13)
+     *
+     * @return a Ptr to a newly created SpectrumValue
+     */
+    virtual Ptr<SpectrumValue> CreateTxPowerSpectralDensity(double txPower, uint8_t channel);
+};
+
+} // namespace ns3
+
+#endif /*  ISM_SPECTRUM_VALUE_HELPER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/spectrum/model/multi-model-spectrum-channel.cc ns-3.39/src/spectrum/model/multi-model-spectrum-channel.cc
--- ns-3.38/src/spectrum/model/multi-model-spectrum-channel.cc	2023-03-16 20:54:23.824869200 -0700
+++ ns-3.39/src/spectrum/model/multi-model-spectrum-channel.cc	2023-07-05 14:23:48.081428300 -0700
@@ -35,6 +35,7 @@
 #include <ns3/spectrum-converter.h>
 #include <ns3/spectrum-phy.h>
 #include <ns3/spectrum-propagation-loss-model.h>
+#include <ns3/spectrum-transmit-filter.h>
 
 #include <algorithm>
 #include <iostream>
@@ -308,6 +309,11 @@
                     }
                 }
 
+                if (m_filter && m_filter->Filter(txParams, *rxPhyIterator))
+                {
+                    continue;
+                }
+
                 NS_LOG_LOGIC("copying signal parameters " << txParams);
                 Ptr<SpectrumSignalParameters> rxParams = txParams->Copy();
                 rxParams->psd = Copy<SpectrumValue>(convertedTxPowerSpectrum);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/spectrum/model/single-model-spectrum-channel.cc ns-3.39/src/spectrum/model/single-model-spectrum-channel.cc
--- ns-3.38/src/spectrum/model/single-model-spectrum-channel.cc	2023-03-16 20:54:23.824869200 -0700
+++ ns-3.39/src/spectrum/model/single-model-spectrum-channel.cc	2023-07-05 14:23:48.081428300 -0700
@@ -34,6 +34,7 @@
 #include <ns3/simulator.h>
 #include <ns3/spectrum-phy.h>
 #include <ns3/spectrum-propagation-loss-model.h>
+#include <ns3/spectrum-transmit-filter.h>
 
 #include <algorithm>
 
@@ -135,6 +136,11 @@
             }
         }
 
+        if (m_filter && m_filter->Filter(txParams, *rxPhyIterator))
+        {
+            continue;
+        }
+
         if ((*rxPhyIterator) != txParams->txPhy)
         {
             Time delay = MicroSeconds(0);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/spectrum/model/spectrum-channel.cc ns-3.39/src/spectrum/model/spectrum-channel.cc
--- ns-3.38/src/spectrum/model/spectrum-channel.cc	2023-03-16 20:54:23.824869200 -0700
+++ ns-3.39/src/spectrum/model/spectrum-channel.cc	2023-07-05 14:23:48.081428300 -0700
@@ -147,6 +147,24 @@
 }
 
 void
+SpectrumChannel::AddSpectrumTransmitFilter(Ptr<SpectrumTransmitFilter> filter)
+{
+    NS_LOG_FUNCTION(this << filter);
+
+    if (m_filter)
+    {
+        filter->SetNext(m_filter);
+    }
+    m_filter = filter;
+}
+
+Ptr<const SpectrumTransmitFilter>
+SpectrumChannel::GetSpectrumTransmitFilter() const
+{
+    return m_filter;
+}
+
+void
 SpectrumChannel::SetPropagationDelayModel(Ptr<PropagationDelayModel> delay)
 {
     NS_ASSERT(!m_propagationDelay);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/spectrum/model/spectrum-channel.h ns-3.39/src/spectrum/model/spectrum-channel.h
--- ns-3.38/src/spectrum/model/spectrum-channel.h	2023-03-16 20:54:23.824869200 -0700
+++ ns-3.39/src/spectrum/model/spectrum-channel.h	2023-07-05 14:23:48.081428300 -0700
@@ -30,6 +30,7 @@
 #include <ns3/spectrum-phy.h>
 #include <ns3/spectrum-propagation-loss-model.h>
 #include <ns3/spectrum-signal-parameters.h>
+#include <ns3/spectrum-transmit-filter.h>
 #include <ns3/traced-callback.h>
 
 namespace ns3
@@ -115,6 +116,23 @@
     Ptr<PropagationLossModel> GetPropagationLossModel();
 
     /**
+     * Add the transmit filter to be used to filter possible signal receptions
+     * at the StartTx() time.  This method may be called multiple
+     * times to chain multiple filters together; the last filter added will
+     * be the first one used in the chain.
+     *
+     * \param filter an instance of a SpectrumTransmitFilter
+     */
+    void AddSpectrumTransmitFilter(Ptr<SpectrumTransmitFilter> filter);
+
+    /**
+     * Get the transmit filter, or first in a chain of transmit filters
+     * if more than one is present.
+     * \returns a pointer to the transmit filter.
+     */
+    Ptr<const SpectrumTransmitFilter> GetSpectrumTransmitFilter() const;
+
+    /**
      * Used by attached PHY instances to transmit signals on the channel
      *
      * \param params the parameters of the signals being transmitted
@@ -237,6 +255,11 @@
      * Frequency-dependent propagation loss model to be used with this channel.
      */
     Ptr<PhasedArraySpectrumPropagationLossModel> m_phasedArraySpectrumPropagationLoss;
+
+    /**
+     * Transmit filter to be used with this channel
+     */
+    Ptr<SpectrumTransmitFilter> m_filter{nullptr};
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/spectrum/model/spectrum-model.h ns-3.39/src/spectrum/model/spectrum-model.h
--- ns-3.38/src/spectrum/model/spectrum-model.h	2023-03-16 20:54:23.824869200 -0700
+++ ns-3.39/src/spectrum/model/spectrum-model.h	2023-07-05 14:23:48.081428300 -0700
@@ -72,7 +72,7 @@
 {
   public:
     /**
-     * Comparison operator. Returns true if the two SpectumModels are identical
+     * Comparison operator. Returns true if the two SpectrumModels are identical
      * \param lhs left operand
      * \param rhs right operand
      * \returns true if the two operands are identical
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/spectrum/model/spectrum-transmit-filter.cc ns-3.39/src/spectrum/model/spectrum-transmit-filter.cc
--- ns-3.38/src/spectrum/model/spectrum-transmit-filter.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/src/spectrum/model/spectrum-transmit-filter.cc	2023-07-05 14:23:48.081428300 -0700
@@ -0,0 +1,90 @@
+/*
+ * Copyright (c) 2022 University of Washington
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ */
+
+#include "spectrum-transmit-filter.h"
+
+#include "spectrum-phy.h"
+#include "spectrum-signal-parameters.h"
+
+#include <ns3/log.h>
+
+namespace ns3
+{
+
+NS_LOG_COMPONENT_DEFINE("SpectrumTransmitFilter");
+
+NS_OBJECT_ENSURE_REGISTERED(SpectrumTransmitFilter);
+
+TypeId
+SpectrumTransmitFilter::GetTypeId()
+{
+    static TypeId tid =
+        TypeId("ns3::SpectrumTransmitFilter").SetParent<Object>().SetGroupName("Spectrum");
+    return tid;
+}
+
+SpectrumTransmitFilter::SpectrumTransmitFilter()
+{
+    NS_LOG_FUNCTION(this);
+}
+
+void
+SpectrumTransmitFilter::DoDispose()
+{
+    NS_LOG_FUNCTION(this);
+    if (m_next)
+    {
+        m_next->Dispose();
+    }
+    m_next = nullptr;
+    Object::DoDispose();
+}
+
+void
+SpectrumTransmitFilter::SetNext(Ptr<SpectrumTransmitFilter> next)
+{
+    m_next = next;
+}
+
+Ptr<const SpectrumTransmitFilter>
+SpectrumTransmitFilter::GetNext() const
+{
+    return m_next;
+}
+
+bool
+SpectrumTransmitFilter::Filter(Ptr<const SpectrumSignalParameters> params,
+                               Ptr<const SpectrumPhy> receiverPhy)
+{
+    NS_LOG_FUNCTION(this << params << receiverPhy);
+    bool result = DoFilter(params, receiverPhy);
+    if (result)
+    {
+        return true;
+    }
+    else if (m_next)
+    {
+        return m_next->Filter(params, receiverPhy);
+    }
+    else
+    {
+        return false;
+    }
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/spectrum/model/spectrum-transmit-filter.h ns-3.39/src/spectrum/model/spectrum-transmit-filter.h
--- ns-3.38/src/spectrum/model/spectrum-transmit-filter.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/src/spectrum/model/spectrum-transmit-filter.h	2023-07-05 14:23:48.081428300 -0700
@@ -0,0 +1,99 @@
+/*
+ * Copyright (c) 2022 University of Washington
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+#ifndef SPECTRUM_TRANSMIT_FILTER_H
+#define SPECTRUM_TRANSMIT_FILTER_H
+
+#include <ns3/object.h>
+
+namespace ns3
+{
+
+struct SpectrumSignalParameters;
+class SpectrumPhy;
+
+/**
+ * \ingroup spectrum
+ *
+ * \brief spectrum-aware transmit filter object
+ *
+ * Interface for transmit filters that permit an early discard of signal
+ * reception before propagation loss models or receiving Phy objects have
+ * to process the signal, for performance optimization purposes.
+ *
+ */
+class SpectrumTransmitFilter : public Object
+{
+  public:
+    SpectrumTransmitFilter();
+
+    /**
+     * \brief Get the type ID.
+     * \return the object TypeId
+     */
+    static TypeId GetTypeId();
+
+    /**
+     * Add a transmit filter to be consulted next if this filter does not
+     * filter the signal
+     *
+     * \param next next transmit filter to add to the chain
+     */
+    void SetNext(Ptr<SpectrumTransmitFilter> next);
+
+    /**
+     * Return the next transmit filter in the chain
+     *
+     * \return next transmit filter in the chain
+     */
+    Ptr<const SpectrumTransmitFilter> GetNext() const;
+
+    /**
+     * Evaluate whether the signal to be scheduled on the receiving Phy should
+     * instead be filtered (discarded) before being processed in this channel
+     * and on the receiving Phy.
+     *
+     * \param params the spectrum signal parameters.
+     * \param receiverPhy pointer to the receiving SpectrumPhy
+     *
+     * \return whether to perform filtering of the signal
+     */
+    bool Filter(Ptr<const SpectrumSignalParameters> params, Ptr<const SpectrumPhy> receiverPhy);
+
+  protected:
+    void DoDispose() override;
+
+  private:
+    /**
+     * Evaluate whether the signal to be scheduled on the receiving Phy should
+     * instead be filtered (discarded) before being processed in this channel
+     * and on the receiving Phy.
+     *
+     * \param params the spectrum signal parameters.
+     * \param receiverPhy pointer to the receiving SpectrumPhy
+     *
+     * \return whether to perform filtering of the signal
+     */
+    virtual bool DoFilter(Ptr<const SpectrumSignalParameters> params,
+                          Ptr<const SpectrumPhy> receiverPhy) = 0;
+
+    Ptr<SpectrumTransmitFilter> m_next{nullptr}; //!< SpectrumTransmitFilter chained to this one.
+};
+
+} // namespace ns3
+
+#endif /* SPECTRUM_TRANSMIT_FILTER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/spectrum/model/three-gpp-channel-model.cc ns-3.39/src/spectrum/model/three-gpp-channel-model.cc
--- ns-3.38/src/spectrum/model/three-gpp-channel-model.cc	2023-03-16 20:54:23.828869000 -0700
+++ ns-3.39/src/spectrum/model/three-gpp-channel-model.cc	2023-07-05 14:23:48.081428300 -0700
@@ -1083,14 +1083,7 @@
 ThreeGppChannelModel::ChannelMatrixNeedsUpdate(Ptr<const ThreeGppChannelParams> channelParams,
                                                Ptr<const ChannelMatrix> channelMatrix)
 {
-    if (channelParams->m_generatedTime > channelMatrix->m_generatedTime)
-    {
-        return true;
-    }
-    else
-    {
-        return false;
-    }
+    return channelParams->m_generatedTime > channelMatrix->m_generatedTime;
 }
 
 Ptr<const MatrixBasedChannelModel::ChannelMatrix>
@@ -1972,7 +1965,7 @@
             // cache the component of the "rxPhaseDiff" terms which depend on the random angle of
             // arrivals only
             double sinRayZoa = sin(rayZoaRadian[nIndex][mIndex]);
-            double sinRayAoa = cos(rayAoaRadian[nIndex][mIndex]);
+            double sinRayAoa = sin(rayAoaRadian[nIndex][mIndex]);
             double cosRayAoa = cos(rayAoaRadian[nIndex][mIndex]);
             sinCosA[nIndex][mIndex] = sinRayZoa * cosRayAoa;
             sinSinA[nIndex][mIndex] = sinRayZoa * sinRayAoa;
@@ -1981,7 +1974,7 @@
             // cache the component of the "txPhaseDiff" terms which depend on the random angle of
             // departure only
             double sinRayZod = sin(rayZodRadian[nIndex][mIndex]);
-            double sinRayAod = cos(rayAodRadian[nIndex][mIndex]);
+            double sinRayAod = sin(rayAodRadian[nIndex][mIndex]);
             double cosRayAod = cos(rayAodRadian[nIndex][mIndex]);
             sinCosD[nIndex][mIndex] = sinRayZod * cosRayAod;
             sinSinD[nIndex][mIndex] = sinRayZod * sinRayAod;
@@ -2147,7 +2140,7 @@
                     sqrt(kLinear / (1 + kLinear)) * ray /
                         pow(10,
                             channelParams->m_attenuation_dB[0] / 10.0); //(7.5-30) for tau = tau1
-                for (uint16_t nIndex = 1; nIndex < hUsn.GetNumPages(); nIndex++)
+                for (size_t nIndex = 1; nIndex < hUsn.GetNumPages(); nIndex++)
                 {
                     hUsn(uIndex, sIndex, nIndex) *=
                         sqrt(1.0 / (kLinear + 1)); //(7.5-30) for tau = tau2...tauN
@@ -2157,11 +2150,11 @@
     }
 
     NS_LOG_DEBUG("Husn (sAntenna, uAntenna):" << sAntenna->GetId() << ", " << uAntenna->GetId());
-    for (uint16_t cIndex = 0; cIndex < hUsn.GetNumPages(); cIndex++)
+    for (size_t cIndex = 0; cIndex < hUsn.GetNumPages(); cIndex++)
     {
-        for (uint16_t rowIdx = 0; rowIdx < hUsn.GetNumRows(); rowIdx++)
+        for (size_t rowIdx = 0; rowIdx < hUsn.GetNumRows(); rowIdx++)
         {
-            for (uint16_t colIdx = 0; colIdx < hUsn.GetNumCols(); colIdx++)
+            for (size_t colIdx = 0; colIdx < hUsn.GetNumCols(); colIdx++)
             {
                 NS_LOG_DEBUG(" " << hUsn(rowIdx, colIdx, cIndex) << ",");
             }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/spectrum/model/trace-fading-loss-model.cc ns-3.39/src/spectrum/model/trace-fading-loss-model.cc
--- ns-3.38/src/spectrum/model/trace-fading-loss-model.cc	2023-03-16 20:54:23.828869000 -0700
+++ ns-3.39/src/spectrum/model/trace-fading-loss-model.cc	2023-07-05 14:23:48.081428300 -0700
@@ -84,7 +84,7 @@
                           "The number of RB the trace is made of (default 100)",
                           UintegerValue(100),
                           MakeUintegerAccessor(&TraceFadingLossModel::m_rbNum),
-                          MakeUintegerChecker<uint8_t>())
+                          MakeUintegerChecker<uint32_t>())
             .AddAttribute(
                 "RngStreamSetSize",
                 "The number of RNG streams reserved for the fading model. The maximum number of "
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/spectrum/model/trace-fading-loss-model.h ns-3.39/src/spectrum/model/trace-fading-loss-model.h
--- ns-3.38/src/spectrum/model/trace-fading-loss-model.h	2023-03-16 20:54:23.828869000 -0700
+++ ns-3.39/src/spectrum/model/trace-fading-loss-model.h	2023-07-05 14:23:48.081428300 -0700
@@ -122,9 +122,9 @@
     Time m_traceLength;               ///< the trace time
     uint32_t m_samplesNum;            ///< number of samples
     Time m_windowSize;                ///< window size
-    uint8_t m_rbNum;                  ///< RB number
+    uint32_t m_rbNum;                 ///< RB number
     mutable Time m_lastWindowUpdate;  ///< time of last window update
-    uint8_t m_timeGranularity;        ///< time granularity
+    uint32_t m_timeGranularity;       ///< time granularity
     mutable uint64_t m_currentStream; ///< the current stream
     mutable uint64_t m_lastStream;    ///< the last stream
     uint64_t m_streamSetSize;         ///< stream set size
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/spectrum/model/two-ray-spectrum-propagation-loss-model.h ns-3.39/src/spectrum/model/two-ray-spectrum-propagation-loss-model.h
--- ns-3.38/src/spectrum/model/two-ray-spectrum-propagation-loss-model.h	2023-03-16 20:54:23.828869000 -0700
+++ ns-3.39/src/spectrum/model/two-ray-spectrum-propagation-loss-model.h	2023-07-05 14:23:48.081428300 -0700
@@ -23,6 +23,8 @@
 #include "ns3/phased-array-spectrum-propagation-loss-model.h"
 #include "ns3/spectrum-signal-parameters.h"
 
+#include <map>
+
 class FtrFadingModelAverageTest;
 class ArrayResponseTest;
 class OverallGainAverageTest;
